local repItemsBound = {
	[139024] = "Highmountain Tribe Insignia", --Soulbound. (250 rep)
	[146938] = "Highmountain Tribe Insignia", --Soulbound. (250 rep)
	[141990] = "Greater Highmountain Tribe Insignia", --Soulbound. (1500 rep)
	[147412] = "Greater Highmountain Tribe Insignia", --Soulbound, Kirin Tor emissary reward. (1500 rep)
	
	[139020] = "Valarjar Insignia", --Soulbound. (250 rep)
	[146935] = "Valarjar Insignia", --Soulbound. (250 rep)
	[141987] = "Greater Valarjar Insignia", --Soulbound. (1500 rep)
	[147414] = "Greater Valarjar Insignia", --Soulbound, Kirin Tor emissary reward. (1500 rep)
	
	[139021] = "Dreamweaver Insignia", --Soulbound. (250 rep)
	[146936] = "Dreamweaver Insignia", --Soulbound. (250 rep)
	[141988] = "Greater Dreamweaver Insignia", --Soulbound. (1500 rep)
	[147411] = "Greater Dreamweaver Insignia", --Soulbound, Kirin Tor emissary reward. (1500 rep)
	
	[139023] = "Court of Farondis Insignia", --Soulbound. (250 rep)
	[146937] = "Court of Farondis Insignia", --Soulbound. (250 rep)
	[141989] = "Greater Court of Farondis Insignia", --Soulbound. (1500 rep)
	[147410] = "Greater Court of Farondis Insignia", --Soulbound, Kirin Tor emissary reward. (1500 rep)
	
	[139026] = "Nightfallen Insignia", --Soulbound. (250 rep)
	[146940] = "Nightfallen Insignia", --Soulbound. (250 rep)
	[141992] = "Greater Nightfallen Insignia", --Soulbound. (750 rep)
	[147413] = "Greater Nightfallen Insignia", --Soulbound, Kirin Tor emissary reward. (750 rep)
	
	[139025] = "Wardens Insignia", --Soulbound. (250 rep)
	[146939] = "Wardens Insignia", --Soulbound. (250 rep)
	[141991] = "Greater Wardens Insignia", --Soulbound. (1500 rep)
	[147415] = "Greater Wardens Insignia", --Soulbound, Kirin Tor emissary reward. (1500 rep)
	
	[152959] = "Argussian Reach Insignia", --Soulbound. (250 rep)
	[152961] = "Greater Argussian Reach Insignia", --Soulbound, Kirin Tor emissary reward. (750 rep)
	
	[152958] = "Army of the Light Insignia", --Soulbound. (250 rep)
	[152956] = "Greater Army of the Light Insignia", --Soulbound, Kirin Tor emissary reward. (750 rep)
	
	[146949] = "Legionfall Insignia", --Soulbound, order hall reward. (250 rep)
	[147727] = "Greater Legionfall Insignia", --Soulbound, Kirin Tor emissary reward. (750 rep)
	
	[142363] = "Mark of Prey", --Talon's Vengeance rep item. (100 rep)
	
	--[127834] = "Ancient Healing Potion",
}

local repItemsBnet = {
	[141341] = "Highmountain Tribe Insignia", --Bnet bound. (250 rep)
	[146944] = "Highmountain Tribe Insignia", --Bnet bound, order hall reward. (250 rep)
	[150928] = "Greater Highmountain Tribe Insignia", --Bnet bound. (1500 rep)
	
	[141338] = "Valarjar Insignia", --Bnet bound. (250 rep)
	[146941] = "Valarjar Insignia", --Bnet bound, order hall reward. (250 rep)
	[150925] = "Greater Valarjar Insignia", --Bnet bound. (1500 rep)
	
	[141339] = "Dreamweaver Insignia", --Bnet bound. (250 rep)
	[146942] = "Dreamweaver Insignia", --Bnet bound, order hall reward. (250 rep)
	[150926] = "Greater Dreamweaver Insignia", --Bnet bound. (1500 rep)
	
	[141340] = "Court of Farondis Insignia", --Bnet bound. (250 rep)
	[146943] = "Court of Farondis Insignia", --Bnet bound, order hall reward. (250 rep)
	[150927] = "Greater Court of Farondis Insignia", --Bnet bound. (1500 rep)
	
	[141343] = "Nightfallen Insignia", --Bnet bound. (250 rep)
	[146946] = "Nightfallen Insignia", --Bnet bound, order hall reward. (250 rep)
	[150930] = "Greater Nightfallen Insignia", --Bnet bound. (750 rep)
	
	[141342] = "Wardens Insignia", --Bnet bound. (250 rep)
	[146945] = "Wardens Insignia", --Bnet bound, order hall reward. (250 rep)
	[150929] = "Greater Wardens Insignia", --Bnet bound. (1500 rep)
	
	[152960] = "Argussian Reach Insignia", --Bnet bound, order hall reward. (250 rep)
	[152954] = "Greater Argussian Reach Insignia", --Bnet bound. (750 rep)
	
	[152957] = "Army of the Light Insignia", --Bnet bound, order hall reward. (250 rep)
	[152955] = "Greater Army of the Light Insignia", --Bnet bound. (750 rep)
	
	[146950] = "Legionfall Insignia", --Bnet bound, order hall reward. (250 rep)
	[152464] = "Greater Legionfall Insignia", --Bnet bound. (750 rep)
	
	--Pandaria
	[94223] = "Stolen Shado-Pan Insignia",
	[94225] = "Stolen Celestial Insignia",
	[94226] = "Stolen Klaxxi Insignia",
	[94227] = "Stolen Golden Lotus Insignia",
}

--This array is created with function so we can alter the array when options are changed.
local armorTokensShared = {}
function Multimod:createArmorTokensShared()
	armorTokensShared = {}
	local armorType = getArmorType()
	--Shared tokens.
	if (Multimod.db.global.itembar_at_unsullied) then
		armorTokensShared[152733] = "Unsullied Trinket"
		armorTokensShared[152799] = "Unsullied Relic"
		armorTokensShared[152740] = "Unsullied Cloak"
		armorTokensShared[152735] = "Unsullied Ring"
		armorTokensShared[152736] = "Unsullied Necklace"
		
		if (armorType == "CLOTH") then
			--Cloth.
			armorTokensShared[152734] = "Unsullied Cloth Mantle"
			armorTokensShared[152742] = "Unsullied Cloth Cuffs"
			armorTokensShared[153135] = "Unsullied Cloth Robes"
			armorTokensShared[153141] = "Unsullied Cloth Mitts"
			armorTokensShared[153144] = "Unsullied Cloth Slippers"
			armorTokensShared[153154] = "Unsullied Cloth Leggings"
			armorTokensShared[153156] = "Unsullied Cloth Sash"
			armorTokensShared[152738] = "Unsullied Cloth Cap"
		elseif (armorType == "LEATHER") then
			armorTokensShared[153145] = "Unsullied Leather Spaulders"
			armorTokensShared[153142] = "Unsullied Leather Armbands"
			armorTokensShared[153151] = "Unsullied Leather Tunic"
			armorTokensShared[152739] = "Unsullied Leather Grips"
			armorTokensShared[153136] = "Unsullied Leather Treads"
			armorTokensShared[152737] = "Unsullied Leather Trousers"
			armorTokensShared[153148] = "Unsullied Leather Belt"
			armorTokensShared[153139] = "Unsullied Leather Headgear"
		elseif (armorType == "MAIL") then
			armorTokensShared[153137] = "Unsullied Mail Spaulders"
			armorTokensShared[153158] = "Unsullied Mail Bracers"
			armorTokensShared[152741] = "Unsullied Mail Chestguard"
			armorTokensShared[153149] = "Unsullied Mail Gloves"
			armorTokensShared[153152] = "Unsullied Mail Boots"
			armorTokensShared[153138] = "Unsullied Mail Legguards"
			armorTokensShared[152744] = "Unsullied Mail Girdle"
			armorTokensShared[153147] = "Unsullied Mail Coif"
		elseif (armorType == "PLATE") then
			armorTokensShared[153153] = "Unsullied Plate Pauldrons"
			armorTokensShared[153150] = "Unsullied Plate Vambraces"
			armorTokensShared[153143] = "Unsullied Plate Breastplate"
			armorTokensShared[153157] = "Unsullied Plate Guantlets"
			armorTokensShared[152743] = "Unsullied Plate Sabatons"
			armorTokensShared[153146] = "Unsullied Plate Greaves"
			armorTokensShared[153140] = "Unsullied Plate Waistplate"
			armorTokensShared[153155] = "Unsullied Plate Helmet"
		end
	end
	
	if (Multimod.db.global.itembar_at_relinquished) then
		armorTokensShared[153206] = "Relinquished Bracers"
		armorTokensShared[153207] = "Relinquished Treads"
		armorTokensShared[153209] = "Relinquished Cloak"
		armorTokensShared[153214] = "Relinquished Ring"
		armorTokensShared[153216] = "Relinquished Trinket"
		armorTokensShared[153205] = "Relinquished Girdle"
		armorTokensShared[153213] = "Relinquished Necklace"
		armorTokensShared[153212] = "Relinquished Leggings"
		armorTokensShared[153211] = "Relinquished Hood"
		armorTokensShared[153210] = "Relinquished Gauntlets"
		armorTokensShared[153208] = "Relinquished Chestguard"
		armorTokensShared[153215] = "Relinquished Spaulders"
		armorTokensShared[153068] = "Relinquished Storm Relic"
		armorTokensShared[153059] = "Relinquished Arcane Relic"
		armorTokensShared[153060] = "Relinquished Blood Relic"
		armorTokensShared[153061] = "Relinquished Fel Relic"
		armorTokensShared[153062] = "Relinquished Fire Relic"
		armorTokensShared[153063] = "Relinquished Frost Relic"
		armorTokensShared[153064] = "Relinquished Holy Relic"
		armorTokensShared[153065] = "Relinquished Iron Relic"
		armorTokensShared[153066] = "Relinquished Life Relic"
		armorTokensShared[153067] = "Relinquished Shadow Relic"
	end
	if (Multimod.db.global.itembar_at_dauntless) then
		armorTokensShared[147223] = "Dauntless Trinket"
		armorTokensShared[147220] = "Dauntless Ring"
		armorTokensShared[147216] = "Dauntless Hood"
		armorTokensShared[147213] = "Dauntless Tunic"
		armorTokensShared[147218] = "Dauntless Spaulders"
		armorTokensShared[147212] = "Dauntless Bracers"
		armorTokensShared[147217] = "Dauntless Leggings"
		armorTokensShared[147219] = "Dauntless Girdle"
		armorTokensShared[147221] = "Dauntless Choker"
		armorTokensShared[147214] = "Dauntless Treads"
		armorTokensShared[147222] = "Dauntless Cloak"
		armorTokensShared[147215] = "Dauntless Gauntlets"
	end
end

local orderHallTroops = {
	--Order Hall Troops.
	[152095] = "Krokul Ridgestalker",
	[152096] = "Void-Purged Krokul",
	[152097] = "Lightforged Bulwark",
	[140924] = "Ashtongue Beacon", --DH class campaign reward.
	[140925] = "Enchanted Bark", --Druid class campaign reward.
	[140923] = "Ghoul Tombstone", --DK class campaign reward.
	[140926] = "Bowmen's Orders", --Hunter class campaign reward.
	[140929] = "Squire's Oath", --Paladin class campaign reward.
	[140930] = "Acolyte's Vows", --Priest class campaign reward.
	[140927] = "Water Globe", --Mage class campaign reward.
	[140928] = "Ox Initiate's Pledge", --Monk class campaign reward.
	[140931] = "Bandit Wanted Poster", --Rogue class campaign reward.
	[140932] = "Earthen Mark", --Shaman class campaign reward.
	[140922] = "Imp Pact", --Warlock class campaign reward.
	[140933] = "Runed Aspirant's Band", --Warrior class campaign reward.
}

--Disabled for now, order hall troop button just uses all kinds.
--This is for skipping troop items you are already full on.
--OrderHall_LoadUI() --Order hall frames need to be loaded.
--[[local refreshOrderHallTroops = true
local categoryInfo
function Multimod:orderHallTroopLimits(type)
	if (refreshOrderHallTroops) then
		OrderHallCommandBarMixin:RequestCategoryInfo()
		refreshOrderHallTroops = false
		categoryInfo = C_Garrison.GetClassSpecCategoryInfo(LE_FOLLOWER_TYPE_GARRISON_7_0);
	end
	for index, category in ipairs(categoryInfo) do
		local name = category.name
		local desc = category.description;
		local current = category.count
		local max = category.limit
		--If type is the item we're checking and we're not at max, return true so the item button can add it.
		if (name == type and current < max) then
			return true
		end
	end
end]]

function Multimod:setButtonAttributes(frame, num)
	if (frame ~= "mmTroopsBtn") then
		_G[frame]:SetAttribute("type", "item")
		_G[frame]:SetAttribute("click", "clickbutton")
	end
	--If num, then it's a custom button and we add different clicks.
	if (num) then
		_G[frame]:SetScript("OnMouseDown", function(self, button)
			if (IsShiftKeyDown() and button == "RightButton") then
				Multimod:showMmCustomButton(num)
			elseif (IsModifierKeyDown() and not self:GetParent().isMoving) then
				self:GetParent():StartMoving();
				self:GetParent().isMoving = true;
			end
		end)
	else
		_G[frame]:SetScript("OnMouseDown", function(self, button)
			if (IsModifierKeyDown() and not self:GetParent().isMoving) then
				self:GetParent():StartMoving();
				self:GetParent().isMoving = true;
			end
		end)
	end
	_G[frame]:SetScript("OnMouseUp", function(self, button)
		if (self:GetParent().isMoving) then
			self:GetParent():StopMovingOrSizing();
			self:GetParent().isMoving = false;
			Multimod.db.global.itembar_point, _, Multimod.db.global.itembar_relativePoint, 
					Multimod.db.global.itembar_x, Multimod.db.global.itembar_y = self:GetParent():GetPoint()
			if (_G['mmFirstLoadItemBar']) then
				mmFirstLoadItemBar:Hide()
			end
		end
	end)
	_G[frame]:SetScript("OnHide", function(self)
		if (self:GetParent().isMoving) then
			self:GetParent():StopMovingOrSizing();
			self:GetParent().isMoving = false;
			if (_G['mmFirstLoadItemBar']) then
				mmFirstLoadItemBar:Hide()
			end
		end
	end)
	_G[frame]:SetScript("OnLeave", function(self)
		GameTooltip_Hide()
	end)
end

-------------------------
--Hidden /click buttons--
-------------------------

--Eastern Kingdoms flight path heirloom toy. "/click fp"
mmFpBtn = CreateFrame("Button", "fp", UIParent, "SecureActionButtonTemplate");
mmFpBtn:SetAttribute("type", "item")
if (UnitFactionGroup("player") == "Horde") then
	mmFpBtn:SetAttribute("item", "The Azeroth Campaign");
else
	mmFpBtn:SetAttribute("item", "To Modernize the Provisioning of Azeroth");
end
mmFpBtn:SetAttribute("click", "clickbutton")

mmFpBtn1 = CreateFrame("Button", "fp1", UIParent, "SecureActionButtonTemplate");
mmFpBtn1:SetAttribute("type", "item")
if (UnitFactionGroup("player") == "Horde") then
	mmFpBtn1:SetAttribute("item", "The Azeroth Campaign");
else
	mmFpBtn1:SetAttribute("item", "To Modernize the Provisioning of Azeroth");
end
mmFpBtn1:SetAttribute("click", "clickbutton")
	
--Kalimdor flight path heirloom toy. "/click fp2"
mmFpBtn2 = CreateFrame("Button", "fp2", UIParent, "SecureActionButtonTemplate");
mmFpBtn2:SetAttribute("type", "item")
if (UnitFactionGroup("player") == "Horde") then
	mmFpBtn2:SetAttribute("item", "Walking Kalimdor with the Earthmother");
else
	mmFpBtn2:SetAttribute("item", "Surviving Kalimdor");
end
mmFpBtn2:SetAttribute("click", "clickbutton")

local buttonCache = {}
function Multimod:createClickButtons()
	--------------------------
	--Visible /click buttons--
	--------------------------
	
	mmItemsParent = CreateFrame("FRAME", "mmItemsParent", UIParent)
	mmItemsParent.bg = mmItemsParent:CreateTexture(nil, "BACKGROUND")
	mmItemsParent.bg:SetAllPoints(true)
	mmItemsParent.bg:SetColorTexture(0, 0, 0, 0.8)
	mmItemsParent:SetPoint("CENTER", 0, 0)
	mmItemsParent:SetMovable(true)
	mmItemsParent:SetScript("OnMouseUp", function(self, button)
		if (self.isMoving) then
			Multimod.db.global.itembar_point, _, Multimod.db.global.itembar_relativePoint, 
					Multimod.db.global.itembar_x, Multimod.db.global.itembar_y = self:GetPoint()
		end
	end)
	mmItemsParent:SetScript("OnHide", function(self)
		if (self.isMoving) then
			Multimod.db.global.itembar_point, _, Multimod.db.global.itembar_relativePoint, 
					Multimod.db.global.itembar_x, Multimod.db.global.itembar_y = self:GetPoint()
		end
	end)
	
	--Order hall troops from argus. "/click troops"
	mmTroopsBtn = CreateFrame("BUTTON", "troops", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate")
	Multimod:setButtonAttributes("mmTroopsBtn")
	mmTroopsBtn:SetAttribute("type", "macro")
	mmTroopsBtn:SetAttribute("macrotext", "/use Krokul Ridgestalker\n/use Void-Purged Krokul\n/use Lightforged Bulwark\n" ..
			"/use Ashtongue Beacon\n" .. --DH class campaign reward. 140924
			"/use Enchanted Bark\n" .. --Druid class campaign reward. 140925
			"/use Ghoul Tombstone\n" .. --DK class campaign reward. 140923
			"/use Bowmen's Orders\n" .. --Hunter class campaign reward. 140926
			"/use Squire's Oath\n" .. --Paladin class campaign reward. 140929
			"/use Acolyte's Vows\n" .. --Priest class campaign reward. 140930
			"/use Water Globe\n" .. --Mage class campaign reward. 140927
			"/use Ox Initiate's Pledge\n" .. --Monk class campaign reward. 14092
			"/use Bandit Wanted Poster\n" .. --Rogue class campaign reward. 140931
			"/use Earthen Mark\n" .. --Shaman class campaign reward. 140932
			"/use Imp Pact\n" .. --Warlock class campaign reward. 140922
			"/use Runed Aspirant's Band\n") --Warrior class campaign reward. 140933
	mmTroopsBtn:SetAttribute("click", "clickbutton")
	mmTroopsBtn.fs = mmTroopsBtn:CreateFontString("mmTroopsBtnFS", "ARTWORK")
	mmTroopsBtn.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmTroopsBtn.fs:SetText("|cffFFFF00Troops")
	mmTroopsBtn.fs:SetPoint("CENTER", 0.5, 0.5)
	
	--Reputation items. "/click rep"
	mmRepBtn = CreateFrame("Button", "rep", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmRepBtn")
	mmRepBtn.fs = mmRepBtn:CreateFontString("mmRepBtnFS", "ARTWORK")
	mmRepBtn.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmRepBtn.fs:SetText("|cffFFFF00Rep\nTokens")
	mmRepBtn.fs:SetPoint("CENTER", 0, 0.5)
	
	--Artifact Power items. "/click ap"
	mmApBtn = CreateFrame("Button", "ap", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmApBtn")
	mmApBtn.fs = mmApBtn:CreateFontString("mmApBtnFS", "ARTWORK")
	mmApBtn.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 12)
	mmApBtn.fs:SetText("|cffFFFF00AP")
	mmApBtn.fs:SetPoint("CENTER", 0.5, 0.5)
	
	--Armor Token items. "/click at"
	mmAtBtn = CreateFrame("Button", "at", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmAtBtn")
	mmAtBtn.fs = mmAtBtn:CreateFontString("mmApBtnFS", "ARTWORK")
	mmAtBtn.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmAtBtn.fs:SetText("|cffFFFF00Armor\nTokens")
	mmAtBtn.fs:SetPoint("CENTER", 0, 0.5)

	--Nethershard items. "/click ns"
	mmNsBtn = CreateFrame("Button", "ns", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmNsBtn")
	mmNsBtn.fs = mmNsBtn:CreateFontString("mmNsBtnFS", "ARTWORK")
	mmNsBtn.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmNsBtn.fs:SetText("|cffFFFF00Nether\nshards")
	mmNsBtn.fs:SetPoint("CENTER", 0, 0.5)
	
	--The all consumables button is disabled, too many items Blizzard have wrongly classed as consumable.
	--All consumables. "/click all"
	--[[mmAllBtn = CreateFrame("Button", "all", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmAllBtn")
	mmAllBtn.fs = mmAllBtn:CreateFontString("mmAllBtnFS", "ARTWORK")
	mmAllBtn.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 12)
	mmAllBtn.fs:SetText("|cffFFFF00All")
	mmAllBtn.fs:SetPoint("CENTER", 0, 0.5)]]
	
	--Custom consumables list. "/click custom"
	mmCustomBtn1 = CreateFrame("Button", "custom", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmCustomBtn1", 1)
	mmCustomBtn1.fs = mmCustomBtn1:CreateFontString("mmCustomBtn1FS", "ARTWORK")
	mmCustomBtn1.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmCustomBtn1.fs:SetText("|cffFFFF00Custom")
	mmCustomBtn1.fs:SetPoint("CENTER", 0, 0.5)
	
	--Custom consumables list. "/click custom2"
	mmCustomBtn2 = CreateFrame("Button", "custom2", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmCustomBtn2", 2)
	mmCustomBtn2.fs = mmCustomBtn2:CreateFontString("mmCustomBtn2FS", "ARTWORK")
	mmCustomBtn2.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmCustomBtn2.fs:SetText("|cffFFFF00Custom\n2")
	mmCustomBtn2.fs:SetPoint("CENTER", 0, -4)
	
	--Custom consumables list. "/click custom3"
	mmCustomBtn3 = CreateFrame("Button", "custom3", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmCustomBtn3", 3)
	mmCustomBtn3.fs = mmCustomBtn3:CreateFontString("mmCustomBtn3FS", "ARTWORK")
	mmCustomBtn3.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmCustomBtn3.fs:SetText("|cffFFFF00Custom\n3")
	mmCustomBtn3.fs:SetPoint("CENTER", 0, -4)
	
	--Custom consumables list. "/click custom4"
	mmCustomBtn4 = CreateFrame("Button", "custom4", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmCustomBtn4", 4)
	mmCustomBtn4.fs = mmCustomBtn4:CreateFontString("mmCustomBtn4FS", "ARTWORK")
	mmCustomBtn4.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmCustomBtn4.fs:SetText("|cffFFFF00Custom\n4")
	mmCustomBtn4.fs:SetPoint("CENTER", 0, -4)
	
	--Custom consumables list. "/click custom5"
	mmCustomBtn5 = CreateFrame("Button", "custom5", mmItemsParent, "ActionButtonTemplate, SecureActionButtonTemplate");
	Multimod:setButtonAttributes("mmCustomBtn5", 5)
	mmCustomBtn5.fs = mmCustomBtn5:CreateFontString("mmCustomBtn5FS", "ARTWORK")
	mmCustomBtn5.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 9)
	mmCustomBtn5.fs:SetText("|cffFFFF00Custom\n5")
	mmCustomBtn5.fs:SetPoint("CENTER", 0, -4)
	
	--OrderHall_LoadUI() --Disabled for now, order hall troop button just uses all kinds.
	Multimod:createArmorTokensShared()
	Multimod:updateItemsFrame()
end

local buttonWidth = 40
local buttonHeight = 40
--Set size and scaling.
function Multimod:updateItemsFrame()
	local width = 0
	local height = 0
	local count = 0
	local last = true
	local buttonCount = 1
	Multimod.buttonCache = {}
	if (Multimod.db.global.itembar_rep) then
		Multimod.buttonCache[buttonCount] = "mmRepBtn"
		buttonCount = buttonCount + 1
	else
		mmRepBtn:Hide()
	end
	if (Multimod.db.global.itembar_troops) then
		Multimod.buttonCache[buttonCount] = "mmTroopsBtn"
		buttonCount = buttonCount + 1
	else
		mmTroopsBtn:Hide()
	end
	if (Multimod.db.global.itembar_ap) then
		Multimod.buttonCache[buttonCount] = "mmApBtn"
		buttonCount = buttonCount + 1
	else
		mmApBtn:Hide()
	end
	if (Multimod.db.global.itembar_at) then
		Multimod.buttonCache[buttonCount] = "mmAtBtn"
		buttonCount = buttonCount + 1
	else
		mmAtBtn:Hide()
	end
	if (Multimod.db.global.itembar_ns) then
		Multimod.buttonCache[buttonCount] = "mmNsBtn"
		buttonCount = buttonCount + 1
	else
		mmNsBtn:Hide()
	end
	--[[if (Multimod.db.global.itembar_all) then
		Multimod.buttonCache[buttonCount] = "mmAllBtn"
		buttonCount = buttonCount + 1
	else
		mmAllBtn:Hide()
	end]]
	if (Multimod.db.global.itembar_custom1) then
		Multimod.buttonCache[buttonCount] = "mmCustomBtn1"
		buttonCount = buttonCount + 1
	else
		mmCustomBtn1:Hide()
	end
	if (Multimod.db.global.itembar_custom2) then
		Multimod.buttonCache[buttonCount] = "mmCustomBtn2"
		buttonCount = buttonCount + 1
	else
		mmCustomBtn2:Hide()
	end
	if (Multimod.db.global.itembar_custom3) then
		Multimod.buttonCache[buttonCount] = "mmCustomBtn3"
		buttonCount = buttonCount + 1
	else
		mmCustomBtn3:Hide()
	end
	if (Multimod.db.global.itembar_custom4) then
		Multimod.buttonCache[buttonCount] = "mmCustomBtn4"
		buttonCount = buttonCount + 1
	else
		mmCustomBtn4:Hide()
	end
	if (Multimod.db.global.itembar_custom5) then
		Multimod.buttonCache[buttonCount] = "mmCustomBtn5"
		buttonCount = buttonCount + 1
	else
		mmCustomBtn5:Hide()
	end
	if (not Multimod.buttonCache[1]) then
		mmItemsParent:Hide()
		return
	else
		mmItemsParent:Show()
	end
	for i, v in ipairs(Multimod.buttonCache) do
		count = count + 1
		_G[v]:SetWidth(buttonWidth)
		_G[v]:SetHeight(buttonHeight)
		if (count == 1) then
			_G[v]:SetPoint("LEFT", width + 1, 0)
			width = width + _G[v]:GetWidth() + 1 -- +1 edge spacing at the start of the button row.
		else
			_G[v]:SetPoint("LEFT", width + 2, 0)
			width = width + _G[v]:GetWidth() +2
		end
		_G[v]:Show()
		height = _G[v]:GetHeight()
		last = i
	end
	mmItemsParent:SetWidth(width) -- +1 edge spacing at the end of the button row.
	mmItemsParent:SetHeight(height)
	mmItemsParent:SetScale(Multimod.db.global.itembar_size)
	if (Multimod.db.global.itembar_point and Multimod.db.global.itembar_relativePoint and 
			Multimod.db.global.itembar_x and Multimod.db.global.itembar_y) then
		mmItemsParent:SetPoint(Multimod.db.global.itembar_point, UIParent, Multimod.db.global.itembar_relativePoint, 
				Multimod.db.global.itembar_x, Multimod.db.global.itembar_y)
	else
		--Tooltip instructions shown if bar has never been moved before.
		mmFirstLoadItemBar = CreateFrame("BUTTON", "mmFirstLoadItemBar", mmItemsParent, "TooltipBorderedFrameTemplate")
		mmFirstLoadItemBar.bg = mmFirstLoadItemBar:CreateTexture(nil, "BACKGROUND")
		mmFirstLoadItemBar:SetPoint("TOP", 0, 40)
		mmFirstLoadItemBar.bg:SetColorTexture(0, 0, 0, 0.8)
		mmFirstLoadItemBar.fs = mmFirstLoadItemBar:CreateFontString("mmFirstLoadItemBarFS", "ARTWORK")
		mmFirstLoadItemBar.fs:SetFont("Interface\\AddOns\\Multimod\\Media\\Segoe UI.ttf", 10)
		mmFirstLoadItemBar.fs:SetText("Hold Shift and click any button to drag.\nType \"/mm\" to configure or disable.")
		mmFirstLoadItemBar.fs:SetPoint("CENTER", 0.5, 0.5)
		mmFirstLoadItemBar:SetWidth(220)
		mmFirstLoadItemBar:SetHeight(35)
		mmFirstLoadItemBar:SetScale(1.1)
	end
end

--Update buttons on bag changes.
local apTooltipCheck = CreateFrame("GameTooltip", "apTooltipCheck", UIParent, "GameTooltipTemplate")
local updateButtonEvents = CreateFrame("Frame")
updateButtonEvents:RegisterEvent("BAG_UPDATE_DELAYED")
updateButtonEvents:SetScript('OnEvent', function(self, event, ...)
	--Disable temp events if one of them are the trigger.
	if (event == "PLAYER_REGEN_ENABLED" or event == "PET_BATTLE_CLOSE" or (event == "UNIT_EXITED_VEHICLE" and ... == "player")) then
		updateButtonEvents:UnregisterEvent("PLAYER_REGEN_ENABLED")
		updateButtonEvents:UnregisterEvent("PET_BATTLE_CLOSE")
		updateButtonEvents:UnregisterEvent("UNIT_EXITED_VEHICLE")
		Multimod:updateItemButtons()
	elseif (event ~= "UNIT_EXITED_VEHICLE") then
		Multimod:updateItemButtons()
	end
end)

function Multimod:updateItemButtons()
	--If in combat lockdown, register to run the update after combat ends, pet battle ends, and exit vehicle.
	if (InCombatLockdown()) then
		updateButtonEvents:RegisterEvent("PLAYER_REGEN_ENABLED")
		updateButtonEvents:RegisterEvent("PET_BATTLE_CLOSE")
		updateButtonEvents:RegisterEvent("UNIT_EXITED_VEHICLE")
		return
	end
	local boundFirst = true
	local doRep = 0
	local doAt = 0
	local doTroops = 0
	local doAp = 0
	local doNs = 0
	--local doAll = 0
	local doCustom1 = 0
	local doCustom2 = 0
	local doCustom3 = 0
	local doCustom4 = 0
	local doCustom5 = 0
	for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
      		local itemLink = GetContainerItemLink(bag, slot)
      		local itemType = false
			if (itemLink and itemLink ~= nil and itemLink ~= '') then
      			local itemName, _, _, _, _, itemType = GetItemInfo(itemLink)
      			local _, _, Color, Ltype, itemId, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl 
						= string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*)" ..
						":?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				--A different pattern match for caged battle pets, GetItemInfo() also fails with caged pets.
				--Caged pets have no itemId in the link, if it's a pet link it will only show up on custom buttons.
				if (itemName == nil or itemName == "") then
					_, _, Color, Ltype, _, _, _, _, _, _, _, itemName 
						= string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*)" ..
						"|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				end
				--|cff0070dd|Hitem:152799::::::::110:253::11::::|h[Unsullied Relic]|h|r
				--|cff1eff00|Hbattlepet:204:1:2:151:10:10:0000000000000000|h[Teldrassil Sproutling]|h|r 
				local itemId = tonumber(itemId)
				local lowerCaseItem = string.lower(itemName)
				--Exceptions because Blizzard has some items wrongly classed as Misc.
				if (orderHallTroops[itemId]) then
      				itemType = "Consumable"
      			end
				if (itemType and itemType == "Consumable") then
    				local itemId = tonumber(itemId)
    				if (Multimod.db.global.itembar_rep and repItemsBound[itemId]) then
    					--Update bound rep items button, first item in bags only.
    					if (doRep < 1) then
    						mmRepBtn:SetAttribute("item", bag .. " " .. slot)
    						Multimod:updateButtonTexture("mmRepBtn", itemLink, bag, slot)
    					end
    					local _, itemCount = GetContainerItemInfo(bag, slot);
    					if (not itemCount) then
    						itemCount = 1
    					end
    					doRep = doRep + 1
    					mmRepBtn.Count:SetText(doRep)
					elseif (Multimod.db.global.itembar_rep and Multimod.db.global.itembar_rep_bnet and repItemsBnet[itemId]) then
						--Update bnet bound rep items button it no bound found, and bnet enabled in options.
						if (doRep < 1) then
    						mmRepBtn:SetAttribute("item", bag .. " " .. slot)
    						Multimod:updateButtonTexture("mmRepBtn", itemLink, bag, slot)
    					end
    					local _, itemCount = GetContainerItemInfo(bag, slot);
    					if (not itemCount) then
    						itemCount = 1
    					end
    					doRep = doRep + itemCount
    					mmRepBtn.Count:SetText(doRep)
    				elseif (Multimod.db.global.itembar_at and armorTokensShared[itemId]) then
						--Update armor tokens.
						if (doAt < 1) then
    						mmAtBtn:SetAttribute("item", bag .. " " .. slot)
    						Multimod:updateButtonTexture("mmAtBtn", itemLink, bag, slot)
    					end
    					local _, itemCount = GetContainerItemInfo(bag, slot);
    					if (not itemCount) then
    						itemCount = 1
    					end
    					doAt = doAt + itemCount
    					mmAtBtn.Count:SetText(doAt)
    				elseif (Multimod.db.global.itembar_troops and orderHallTroops[itemId]) then
						--Update order hall troop tokens if we're not maxed on this troop type.
						--if (Multimod:orderHallTroopLimits(itemName)) then
							if (doTroops < 1) then
								--mmTroopsBtn:SetAttribute("item", bag .. " " .. slot) --This is a macro for now instead.
								Multimod:updateButtonTexture("mmTroopsBtn", itemLink, bag, slot)
							end
							local _, itemCount = GetContainerItemInfo(bag, slot);
							if (not itemCount) then
    							itemCount = 1
    						end
    						doTroops = doTroops + itemCount
    						mmTroopsBtn.Count:SetText(doTroops)
    					--end
    				elseif ((Multimod.db.global.itembar_ns and itemId == 147729) 
    						or (Multimod.db.global.itembar_ns_bnet and itemId == 147726)) then
						--Update nethershard button.
						if (doNs < 1) then
							mmNsBtn:SetAttribute("item", bag .. " " .. slot)
							Multimod:updateButtonTexture("mmNsBtn", itemLink, bag, slot)
						end
						local _, itemCount = GetContainerItemInfo(bag, slot);
						if (not itemCount) then
    						itemCount = 1
    					end
    					doNs = doNs + itemCount
    					mmNsBtn.Count:SetText(doNs)
					elseif (Multimod.db.global.itembar_ap) then
						--If nothing else found then run AP item check.
						local _, _, _, _, _, itemType = GetItemInfo(GetContainerItemLink(bag, slot))
						if (itemType and itemType == "Consumable") then
							apTooltipCheck:SetOwner(UIParent, "ANCHOR_NONE")
							apTooltipCheck:SetHyperlink(itemLink)
							for i = 1, apTooltipCheck:NumLines() do
								local apTooltipText = _G["apTooltipCheckTextLeft" .. i]:GetText()
								if (apTooltipText) then
									local apAmount = false
									local apAmount = string.match(apTooltipText, "Use: Grants (.+) Artifact Power")
									if (apAmount) then
										if (doAp < 1) then
											mmApBtn:SetAttribute("item", bag .. " " .. slot)
											Multimod:updateButtonTexture("mmApBtn", itemLink, bag, slot)
										end
										local _, itemCount = GetContainerItemInfo(bag, slot);
										if (not itemCount) then
    										itemCount = 1
    									end
    									doAp = doAp + itemCount
    									mmApBtn.Count:SetText(doAp)
    									--Break loop on first line of tooltip text if AP is found.
    									break
									end
								end
							end
						end
					end
					--The all consumables is disabled, too many items Blizzard have wrongly classed as consumable.
					--I may do tooltip scanning for this later.
					--[[if (doAll) then
						--Update the All consumables button.
						local _, _, _, _, _, itemType = GetItemInfo(GetContainerItemLink(bag, slot))
						if (itemType and itemType == "Consumable" and itemId ~= 71083) then --71083 Darkmoon game token.
							if (doAll < 1) then
								mmAllBtn:SetAttribute("item", bag .. " " .. slot)
								Multimod:updateButtonTexture("mmAllBtn", itemLink, bag, slot)
							end
							local _, itemCount = GetContainerItemInfo(bag, slot);
							if (not itemCount) then
    						itemCount = 1
    						end
    						doAll = doAll + itemCount
    						mmAllBtn.Count:SetText(doAll)
						end
					end]]
				end
				--Custom button 1
				if (Multimod.db.global.itembar_custom1) then
					if (Multimod.db.global.itembar_custom_partial1) then
						for key, value in pairs(Multimod.data.global.itembar_custom_list1) do
							if (string.match(lowerCaseItem, key)) then
								--Update custom items list button.
								if (doCustom1 < 1) then
									mmCustomBtn1:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn1", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom1 = doCustom1 + itemCount
    							mmCustomBtn1.Count:SetText(doCustom1)
    						end
    					end
    				else
    					for key, value in pairs(Multimod.data.global.itembar_custom_list1) do
							if (lowerCaseItem == key) then
								--Update custom items list button.
								if (doCustom1 < 1) then
									mmCustomBtn1:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn1", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom1 = doCustom1 + itemCount
    							mmCustomBtn1.Count:SetText(doCustom1)
    						end
    					end
					end
				end
				--Custom button 2
				if (Multimod.db.global.itembar_custom2) then
					if (Multimod.db.global.itembar_custom_partial2) then
						for key, value in pairs(Multimod.data.global.itembar_custom_list2) do
							if (string.match(lowerCaseItem, key)) then
								--Update custom items list button.
								if (doCustom2 < 1) then
									mmCustomBtn2:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn2", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom2 = doCustom2 + itemCount
    							mmCustomBtn2.Count:SetText(doCustom2)
    						end
						end
					else
						for key, value in pairs(Multimod.data.global.itembar_custom_list2) do
							if (lowerCaseItem == key) then
								--Update custom items list button.
								if (doCustom2 < 1) then
									mmCustomBtn2:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn2", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom2 = doCustom2 + itemCount
    							mmCustomBtn2.Count:SetText(doCustom2)
    						end
						end
					end
				end
				--Custom button 3
				if (Multimod.db.global.itembar_custom3) then
					if (Multimod.db.global.itembar_custom_partial3) then
						for key, value in pairs(Multimod.data.global.itembar_custom_list3) do
							if (string.match(lowerCaseItem, key)) then
								--Update custom items list button.
								if (doCustom3 < 1) then
									mmCustomBtn3:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn3", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom3 = doCustom3 + itemCount
    							mmCustomBtn3.Count:SetText(doCustom3)
    						end
						end
					else
						for key, value in pairs(Multimod.data.global.itembar_custom_list3) do
							if (lowerCaseItem == key) then
								--Update custom items list button.
								if (doCustom3 < 1) then
									mmCustomBtn3:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn3", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom3 = doCustom3 + itemCount
    							mmCustomBtn3.Count:SetText(doCustom3)
    						end
						end
					end
				end
				--Custom button 4
				if (Multimod.db.global.itembar_custom4) then
					if (Multimod.db.global.itembar_custom_partial4) then
						for key, value in pairs(Multimod.data.global.itembar_custom_list4) do
							if (string.match(lowerCaseItem, key)) then
								--Update custom items list button.
								if (doCustom4 < 1) then
									mmCustomBtn4:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn4", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom4 = doCustom4 + itemCount
    							mmCustomBtn4.Count:SetText(doCustom4)
    						end
						end
					else
						for key, value in pairs(Multimod.data.global.itembar_custom_list4) do
							if (lowerCaseItem == key) then
								--Update custom items list button.
								if (doCustom4 < 1) then
									mmCustomBtn4:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn4", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom4 = doCustom4 + itemCount
    							mmCustomBtn4.Count:SetText(doCustom4)
    						end
						end
					end
				end
				--Custom button 5
				if (Multimod.db.global.itembar_custom5) then
					if (Multimod.db.global.itembar_custom_partial5) then
						for key, value in pairs(Multimod.data.global.itembar_custom_list5) do
							if (string.match(lowerCaseItem, key)) then
								--Update custom items list button.
								if (doCustom5 < 1) then
									mmCustomBtn5:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn5", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom5 = doCustom5 + itemCount
    							mmCustomBtn5.Count:SetText(doCustom5)
    						end
						end
					else
						for key, value in pairs(Multimod.data.global.itembar_custom_list5) do
							if (lowerCaseItem == key) then
								--Update custom items list button.
								if (doCustom5 < 1) then
									mmCustomBtn5:SetAttribute("item", bag .. " " .. slot)
									Multimod:updateButtonTexture("mmCustomBtn5", itemLink, bag, slot)
								end
								local _, itemCount = GetContainerItemInfo(bag, slot);
								if (not itemCount) then
    								itemCount = 1
    							end
    							doCustom5 = doCustom5 + itemCount
    							mmCustomBtn5.Count:SetText(doCustom5)
    						end
						end
					end
				end
			end
		end
	end
	if (doRep == 0) then
		mmRepBtn.icon:SetTexture(nil)
		mmRepBtn.Count:SetText(nil)
		mmRepBtn.fs:Show()
		mmRepBtn:SetAttribute("item", "0 0")
	end
	if (doAt == 0) then
		mmAtBtn.icon:SetTexture(nil)
		mmAtBtn.Count:SetText(nil)
		mmAtBtn.fs:Show()
		mmAtBtn:SetAttribute("item", "0 0")
	end
	if (doTroops == 0) then
		mmTroopsBtn.icon:SetTexture(nil)
		mmTroopsBtn.Count:SetText(nil)
		mmTroopsBtn.fs:Show()
		mmTroopsBtn:SetAttribute("item", "0 0")
	end
	if (doAp == 0) then
		mmApBtn.icon:SetTexture(nil)
		mmApBtn.Count:SetText(nil)
		mmApBtn.fs:Show()
		mmApBtn:SetAttribute("item", "0 0")
	end
	if (doNs == 0) then
		mmNsBtn.icon:SetTexture(nil)
		mmNsBtn.Count:SetText(nil)
		mmNsBtn.fs:Show()
		mmNsBtn:SetAttribute("item", "0 0")
	end
	--[[if (doAll == 0) then
		mmAllBtn.icon:SetTexture(nil)
		mmAllBtn.Count:SetText(nil)
		mmAllBtn.fs:Show()
		mmAllBtn:SetAttribute("item", "0 0")
	end]]
	if (doCustom1 == 0) then
		mmCustomBtn1.icon:SetTexture(nil)
		mmCustomBtn1.Count:SetText(nil)
		mmCustomBtn1.fs:Show()
		mmCustomBtn1:SetAttribute("item", "0 0")
	end
	if (doCustom2 == 0) then
		mmCustomBtn2.icon:SetTexture(nil)
		mmCustomBtn2.Count:SetText(nil)
		mmCustomBtn2.fs:Show()
		mmCustomBtn2:SetAttribute("item", "0 0")
	end
	if (doCustom3 == 0) then
		mmCustomBtn3.icon:SetTexture(nil)
		mmCustomBtn3.Count:SetText(nil)
		mmCustomBtn3.fs:Show()
		mmCustomBtn3:SetAttribute("item", "0 0")
	end
	if (doCustom4 == 0) then
		mmCustomBtn4.icon:SetTexture(nil)
		mmCustomBtn4.Count:SetText(nil)
		mmCustomBtn4.fs:Show()
		mmCustomBtn4:SetAttribute("item", "0 0")
	end
	if (doCustom5 == 0) then
		mmCustomBtn5.icon:SetTexture(nil)
		mmCustomBtn5.Count:SetText(nil)
		mmCustomBtn5.fs:Show()
		mmCustomBtn5:SetAttribute("item", "0 0")
	end
	Multimod:createCustomButtonList(1)
	refreshOrderHallTroops = true
end

function Multimod:updateButtonTexture(frame, itemLink, bag, slot)
	local itemTexture = GetItemIcon(itemLink)
	_G[frame].icon:SetTexture(itemTexture)
	_G[frame]:SetScript("OnEnter", function(self)
		--Swap tooltip to bottom if buttons are in top half of screen.
		local screenRegion = _G[frame]:GetParent():GetPoint()
		if (screenRegion == "TOPLEFT" or screenRegion == "TOPRIGHT") then
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOM")
		else
			GameTooltip:SetOwner(self, "ANCHOR_TOP")
		end
		if (Multimod.db.global.itembar_tooltips and _G[frame].icon:GetTexture() ~= nil) then
			GameTooltip:SetHyperlink(itemLink)
		end
	end)
	_G[frame]:SetScript("OnLeave", function(self)
		GameTooltip_Hide()
	end)
	_G[frame].fs:Hide()
	startTime, duration, isEnabled = GetContainerItemCooldown(bag, slot)
	if (isEnabled == 1 and duration > 0) then
		_G[frame].cooldown:SetCooldown(startTime, duration)
	--elseif (_G[frame].cooldown:GetCooldownDuration() > 0) then
		--self.cooldown:SetCooldown(0, 0)
	end
end

-----------------------------------------
--Create frames for custom button lists--
-----------------------------------------


function Multimod:showMmCustomButton(num)
	if (_G['mmCustomButton' .. num] and _G['mmCustomButton' .. num]:IsVisible()) then
    	_G['mmCustomButton' .. num]:Hide()
    else
    	Multimod:createCustomButtonList(num)
    	_G['mmCustomButton' .. num]:Show()
    	_G['mmCustomButton' .. num]:SetFrameLevel(1000)
    	_G['mmCustomButton' .. num]:SetFrameStrata("DIALOG")
    end
end

--Create custom button item list frame, or just update list if frame exists.
function Multimod:createCustomButtonList(num)
	--Multimod.data.global.itembar_custom_list1 = {"test", "test2"}
	--The following vars are here so I can easily change this code for use elsewhere.
	--Set the name of the frame.
	local frameName = "mmCustomButton" .. num
	--Set the data array containing the font string list.
	local fontStringDataArray = {}
	if (Multimod.data.global['itembar_custom_list' .. num]) then
		fontStringDataArray = Multimod.data.global['itembar_custom_list' .. num]
	end
	--The base dimensions.
	local frameheight = 340
	local framewidth = 280
	local scrollheight = 0
	local growwidth = 0
	local padding = 2
	
	---Create frames if they don't exist already---
	if (not _G[frameName]) then
		local obj = CreateFrame("ScrollFrame", frameName, nil, "InsetFrameTemplate")
		obj:Hide()
		obj:SetToplevel(true)
		obj:SetMovable(true)
		obj:EnableMouse(true)
		obj:SetPoint("CENTER", UIParent, -100, 100)
		obj:SetSize(framewidth, frameheight)
		tinsert(UISpecialFrames, frameName .. num)
		obj:SetScript("OnMouseDown", function(self, button)
			if button == "LeftButton" and not self.isMoving then
				self:StartMoving();
				self.isMoving = true;
			end
		end)
		obj:SetScript("OnMouseUp", function(self, button)
			if button == "LeftButton" and self.isMoving then
				self:StopMovingOrSizing();
				self.isMoving = false;
			end
		end)
		obj:SetScript("OnHide", function(self)
			if (self.isMoving) then
				self:StopMovingOrSizing();
				self.isMoving = false;
			end
		end)
		
		--Create the scroll bar slider.
		obj.ScrollBar = CreateFrame("Slider", frameName .. "ScrollBar", obj, "UIPanelScrollBarTemplate")
		obj.ScrollBar.bg = obj.ScrollBar:CreateTexture(nil, "BACKGROUND")
		obj.ScrollBar.bg:SetAllPoints(true)
		obj.ScrollBar.bg:SetColorTexture(0, 0, 0, 0.6)
		obj.ScrollBar:SetOrientation("VERTICAL");
		obj.ScrollBar:SetSize(16, frameheight - 49) --Minus 49 to make the X close button flush with the top of the main frame.
		obj.ScrollBar:SetPoint("TOPLEFT", _G[frameName], "TOPRIGHT", 0, -34)
		obj.ScrollBar:SetScript("OnValueChanged", function(self)
			obj:SetVerticalScroll(self:GetValue())
		end)
		
		--Top right X close button.
		obj.closeButton = CreateFrame("Button", frameName .. "xClose", obj.ScrollBar, "UIPanelCloseButton")
		obj.closeButton:SetPoint("Top", 0.25, 41)
		obj.closeButton:SetWidth(31)
		obj.closeButton:SetHeight(31)
		obj.closeButton:SetScript("OnClick", function(self, arg)
			obj:Hide()
		end)
		
		--Top bar for the title.
		obj.topBar = CreateFrame("Frame", frameName .. "topBar", obj, "ThinGoldEdgeTemplate")
		obj.topBar:SetPoint("TOP", 0, 16)
		obj.topBar:SetWidth(150)
		obj.topBar:SetHeight(18)
		obj.topBar.fs = obj.topBar:CreateFontString("topBarFS", "OVERLAY")
		obj.topBar.fs:SetFont("Fonts\\ARIALN.ttf", 11)
		obj.topBar.fs:SetText("|cff00C800Custom Item List |cffFFD100(" .. num .. ")")
		obj.topBar.fs:SetPoint("CENTER", 0, 0)
		obj.topBar:SetMovable(true)
		obj.topBar:EnableMouse(true)
		obj.topBar:SetScript("OnMouseDown", function(self, button)
			if button == "LeftButton" and not self:GetParent().isMoving then
				self:GetParent():StartMoving();
				self:GetParent().isMoving = true;
			end
		end)
		obj.topBar:SetScript("OnMouseUp", function(self, button)
			if button == "LeftButton" and self:GetParent().isMoving then
				self:GetParent():StopMovingOrSizing();
				self:GetParent().isMoving = false;
			end
		end)
		obj.topBar:SetScript("OnHide", function(self)
			if (self:GetParent().isMoving) then
				self:GetParent():StopMovingOrSizing();
				self:GetParent().isMoving = false;
			end
		end)
		
		--Bottom close button.
		obj.bottomButton = CreateFrame("Button", frameName .. "BottomButton", obj, "UIPanelButtonTemplate")
		obj.bottomButton:SetPoint("Bottom", 0, -20)
		obj.bottomButton:SetWidth(80)
		obj.bottomButton:SetHeight(22)
		obj.bottomButton:SetText("Close")
		obj.bottomButton:SetNormalFontObject("GameFontNormalSmall")
		obj.bottomButton:SetScript("OnClick", function(self, arg)
			obj:Hide()
		end)
		
		--Top input box.
		obj.InputBox = mmAceGUI:Create("EditBox")
		obj.InputBox.frame:SetParent(obj)
		obj.InputBox:SetPoint("TOP", 0, -10)
		obj.InputBox.frame:SetScale(0.8)
		obj.InputBox.frame:Show()
		obj.InputBox.frame.fs = obj.InputBox.frame:CreateFontString(frameName .. "topBarFS", "OVERLAY")
		obj.InputBox.frame.fs:SetFont("Fonts\\ARIALN.ttf", 11)
		obj.InputBox.frame.fs:SetText("|cffFFFFFFType or Drag Item Here")
		obj.InputBox.frame.fs:SetPoint("CENTER", 0, 0)
		obj.InputBox:SetCallback("OnEnterPressed", function(self, event, value)
			local funcName = "setItemBarCustomList" .. num
			Multimod[funcName](Multimod, nil, value)
			--Update list currently being viewed.
			Multimod:createCustomButtonList(num)
			obj.InputBox:ClearFocus()
			obj.InputBox:SetText("")
			--Update item button.
			Multimod:updateItemButtons()
		end)
		
		--Create and set the scrollchild with a font string array.
		obj.ScrollChild = CreateFrame("Frame", frameName .. "ScrollChild")
		obj.ScrollChild.FontStrings = {}
		obj.ScrollChild.RemoveButtons = {}
		obj:SetScrollChild(obj.ScrollChild)
		--Create the global for this frame.
		_G[frameName] = obj
	end
	
	---Update the font strings---
	
	--Wipe any current font strings before we add new ones.
	for i, v in ipairs(_G[frameName].ScrollChild.FontStrings) do
		v:SetPoint("LEFT", 0, 0)
		v:SetFont("Fonts\\ARIALN.ttf", 11)
		v:SetText("")
	end
	
	--Hide old "Remove" buttons.
	for i, v in ipairs(_G[frameName].ScrollChild.RemoveButtons) do
		v:Hide()
	end
	
	--Create new font string list.
	local fontStringList = {}
	local foundItems = true
	if (next(fontStringDataArray) == nil) then
		table.insert(fontStringList, "|cffFFFF00No items added yet.")
		foundItems = nil
	else
		for key, value in pairsByKeys(fontStringDataArray) do
			fontStringList[key] = value
			--table.insert(fontStringList, value)
		end
	end
	
	--Iterate the font string list to insert them and update the scroll size to match.
	local index = 0
	for com, fname in pairsByKeys(fontStringList) do
		index = index + 1
		
		--Create remove button for each string.
		if (foundItems) then
			if (not _G[frameName].ScrollChild.RemoveButtons[index]) then
				_G[frameName].ScrollChild.RemoveButtons[index] = CreateFrame("Button", "removeButton" .. index, _G[frameName].ScrollChild, "UIPanelButtonTemplate")
			end
			_G[frameName].ScrollChild.RemoveButtons[index]:SetWidth(70)
			_G[frameName].ScrollChild.RemoveButtons[index]:SetHeight(16)
			_G[frameName].ScrollChild.RemoveButtons[index]:SetText("Remove")
			_G[frameName].ScrollChild.RemoveButtons[index]:SetScale(0.75)
			_G[frameName].ScrollChild.RemoveButtons[index]:SetNormalFontObject("GameFontNormalSmall")
			_G[frameName].ScrollChild.RemoveButtons[index]:SetScript("OnClick", function(self, arg)
				Multimod.data.global['itembar_custom_list' .. num][string.lower(com)] = nil
				--Update list currently being viewed.
				Multimod:createCustomButtonList(num)
				--Update item button.
				Multimod:updateItemButtons()
			end)
			_G[frameName].ScrollChild.RemoveButtons[index]:Show()
		end
		--Create the fontstring index for this line if it doesn't exist.
		if (not _G[frameName].ScrollChild.FontStrings[index]) then
			_G[frameName].ScrollChild.FontStrings[index] = _G[frameName].ScrollChild:CreateFontString(frameName .. "FS", "OVERLAY")
		end
		local fontstring = _G[frameName].ScrollChild.FontStrings[index]
		fontstring:SetPoint("LEFT", 0, 0)
		fontstring:SetFont("Fonts\\ARIALN.ttf", 11)
		fontstring:SetText("|cff00C800" .. index .. ")|CffFFFFFF  " .. ucfirst(fname))
		local fswidth = fontstring:GetStringWidth()
		local fsheight = fontstring:GetStringHeight()
		--First line, set the anchor point for the rest to follow below.
		if (index == 1) then
			--_G[frameName].ScrollChild.RemoveButtons[index]:SetPoint("TOPLEFT", 0, -10)
			fontstring:SetPoint("TOPLEFT", 65, -34) --Width should be 10 without the buttons.
			--_G[frameName].ScrollChild.RemoveButtons[index]:SetPoint("LEFT", 0, 0)
			if (foundItems) then
				fontstring:SetPoint("TOPLEFT", 65, -34) --Width should be 10 without the buttons.
				_G[frameName].ScrollChild.RemoveButtons[index]:SetPoint("LEFT", _G[frameName].ScrollChild.FontStrings[index], "LEFT", -78, -1)
			else
				fontstring:SetText("|CffFFFFFF" .. fname)
				fontstring:SetPoint("TOPLEFT", 10, -34)
			end
			scrollheight = scrollheight + fsheight
		else
			--_G[frameName].ScrollChild.RemoveButtons[index]:SetPoint("TOPLEFT", _G[frameName].ScrollChild.FontStrings[index - 1], "BOTTOMLEFT", -60, - padding)
			fontstring:SetPoint("TOPLEFT", _G[frameName].ScrollChild.FontStrings[index - 1], "BOTTOMLEFT", 0, - padding)
			if (foundItems) then
				_G[frameName].ScrollChild.RemoveButtons[index]:SetPoint("LEFT", _G[frameName].ScrollChild.FontStrings[index], "LEFT", -78, -1)
			end
			scrollheight = scrollheight + fsheight + padding
		end
		--Store the font string width incase we enabled growing the frame wider to match size.
		growwidth = (fswidth > framewidth) and fswidth or growwidth
	end

	--Set the size of the scroll child to match the text height.
	_G[frameName].ScrollChild:SetSize(framewidth, scrollheight)
	
	--Set the scrollbar values to match scroll child size.
	local scrollMax = scrollheight - 200
	if (scrollMax < 2) then
		scrollMax = 2
	end
	_G[frameName].ScrollBar:SetMinMaxValues(0, scrollMax)
	_G[frameName].ScrollBar:SetValue(0)
	
	--Enabled mousewheel scrolling and set values to match scroll child size.
	_G[frameName]:EnableMouseWheel(true)
	_G[frameName]:SetScript("OnMouseWheel", function(self, delta)
		local current = _G[frameName].ScrollBar:GetValue()
		if IsShiftKeyDown() and (delta > 0) then
			_G[frameName].ScrollBar:SetValue(0)
		elseif IsShiftKeyDown() and (delta < 0) then
			_G[frameName].ScrollBar:SetValue(scrollMax)
		elseif (delta < 0) and (current < scrollMax) then
			_G[frameName].ScrollBar:SetValue(current + 20)
		elseif (delta > 0) and (current > 1) then
			_G[frameName].ScrollBar:SetValue(current - 20)
		end
	end)
	--Uncomment these to grow frame wider if the text is wider than the default frame.
	--_G[frameName]:SetSize(growwidth, frameheight)
	--_G[frameName].ScrollChild:SetSize(growwidth, scrollheight)
end