------------------------------------
--Commands ingame panel (/mm help)--
------------------------------------
--These sites helped me work out this frame stuff.
--http://wowwiki.wikia.com
--http://wowprogramming.com/
--Thanks to the author of this thread "zork" for their template list.
--http://www.wowinterface.com/forums/showthread.php?t=40444

function Multimod:showCommandList()
    if mmCommandsFrame:IsVisible() then
    	mmCommandsFrame:Hide()
    else
    	mmCommandsFrame:Show()
    	mmCommandsFrame:SetFrameLevel(1000)
    	mmCommandsFrame:SetFrameStrata("DIALOG")
    end
end

local commandArray = {
	"", --Empty string for spacing.
	"|cffDEDE42A basic command list for broadcasting or adding to macros etc. (scroll down for more)",
	"|cffff8700/multimod or /mm - |cffffffffOpen the options for this addon.",
	"|cffff8700/bnetinvite <name> - |cffffffffInvites all online chars of a friend on Battle.net RealID (/bnetinv also works).",
	"|cffff8700/token - |cffffffffDisplays current WoW token price.",
	"|cffff8700/invasion - |cffffffffTells you how long till next Legion invasion, or when current invasion ends.",
	"|cffff8700/scan - |cffffffffScans your bags for higher level items than you have equipped.",
	"|cffff8700/scanequip - |cffffffffThe same as /scan for finding higher items in bags, but also equips them at the same time.",
	"|cffff8700/grant - |cffffffffGrant a level to target (RAF), there's an option in /mm to auto accept granted levels.",
	"|cffff8700/done - |cffffffffLeaves party, named \"done\" because I would use it to leave finished dungeons.",
	"|cffff8700/in - |cffffffffTeleport to a dungeon you're already in a group for.",
	"|cffff8700/out - |cffffffffTeleport out of a dungeon without leaving group (for quest hand ins etc).",
	"|cffff8700/pvpon - |cffffffffTurns on pvp flag.",
	"|cffff8700/pvpoff - |cffffffffTurns off pvp flag.",
	"|cffff8700/closeall - |cffffffffCloses all windows, same as pressing escape but doesn't open WoW options menu.",
	"|cffff8700/greys - |cffffffffSell all greys, checks if shop is open first so you don't accidently equip them.",
	"|cffff8700/cam - |cffffffffResets cam to the middle.",
	"|cffff8700/passloot - |cffffffffPass on loot rolls, slave chars pass while running leveling dungs etc (personal loot still works).",
	"|cffff8700/passlootoff - |cffffffffStop passing on loot, it resets when logging off anyway though.",
	"|cffff8700/followspam <name> - |cffffffffSpams follow on <target> every 2 seconds, \"/followspam stop\" to stop.",
	"|cffff8700/destroylove - |cffffffffDestroy all unsellable Love is in the Air items (checklist is in options).",
	"|cffff8700/destroyhalloween - |cffffffffDestroy all unsellable Halloween items (checklist is in options).",
	"|cffff8700/destroyxmas - |cffffffffDestroy all unsellable Winter Veil items (checklist is in options).",
	"|cffff8700/destroyeggs - |cffffffffDestroy all Fel-Spotted Eggs from Argus.",
	"|cffff8700/destroyargus - |cffffffffDestroy all unsellable Argus items including eggs (checklist is in options).",
	"|cffff8700/destroyat - |cffffffffDestroy all Argus Unsullied Armor Tokens. (sells instead if shop open, checklist is in options)",
	"|cffff8700/destroylooms - |cffffffffDestroy all unequipped Heirlooms, skips enchanted looms unless you tick it in options.",
	"|cffff8700/destroyall - |cffffffffRuns all /destroy commands at once, good for bag cleaning.",
	"|cffff8700/luaon - |cffffffffTurns on lua errors.",
	"|cffff8700/luaoff - |cffffffffTurns off lua errors.",
	"", --Empty string for spacing.
	"|cffDEDE42Click commands that can be put into macros or typed:", --Empty string for spacing.
	"|cffff8700/click fp1 - |cffffffffUse flight path heirloom toy for Eastern Kingdoms.",
	"|cffff8700/click fp2 - |cffffffffUse flight path heirloom toy for Kalimdor.",
	"|cffff8700/click rep - |cffffffffUse itembar button: Reputation tokens.",
	"|cffff8700/click troops - |cffffffffUse itembar button: Argus troops.",
	"|cffff8700/click ap - |cffffffffUse itembar button: Artifact power.",
	"|cffff8700/click at - |cffffffffUse itembar button: Armor tokens.",
	"|cffff8700/click ns - |cffffffffUse itembar button: Nethershard tokens.",
	"|cffff8700/click custom - |cffffffffUse itembar button: Cuttom button 1.",
	"|cffff8700/click custom2 - |cffffffffUse itembar button: Cuttom button 2.",
	"|cffff8700/click custom3 - |cffffffffUse itembar button: Cuttom button 3.",
	"|cffff8700/click custom4 - |cffffffffUse itembar button: Cuttom button 4.",
	"|cffff8700/click custom5 - |cffffffffUse itembar button: Cuttom button 5.",
}

local mmCommands = CreateFrame("ScrollFrame", "mmCommandsFrame", mmCommands, "InsetFrameTemplate")
--mmCommands.bg = mmCommands:CreateTexture(nil, "BACKGROUND")
--mmCommands.bg:SetAllPoints(true)
--mmCommands.bg:SetColorTexture(0, 0, 0, 0.9)
mmCommandsFrame:SetToplevel(true)
mmCommandsFrame:SetMovable(true)
mmCommandsFrame:EnableMouse(true)
mmCommandsFrame:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving();
		self.isMoving = true;
	end
end)
mmCommandsFrame:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)
mmCommandsFrame:SetScript("OnHide", function(self)
	if (self.isMoving) then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)

local mmCommandsScrollChild = CreateFrame("Frame", "mmCommandsScrollChildFrame")
 
-- Create the slider that will be used to scroll through the results
local mmCommandsScrollBar = CreateFrame("Slider", "mmCommandsScrollBarFrame", mmCommands, "UIPanelScrollBarTemplate")
mmCommandsScrollBar.bg = mmCommandsScrollBar:CreateTexture(nil, "BACKGROUND")
mmCommandsScrollBar.bg:SetAllPoints(true)
mmCommandsScrollBar.bg:SetColorTexture(0, 0, 0, 0.6)

-- Create a table that will contain the font strings themselves
mmCommandsScrollChild.fstrings = mmCommandsScrollChild.fstrings or {}
 
-- This changes the padding between font strings vertically
local PADDING = 5
 
-- Store the max width and overall height of the scroll child
local height = 0
local width = 0
 
-- Iterate the list of fonts collected
local index = 0
for com, fname in ipairs(commandArray) do
	index = index + 1
   -- If the font string is not created, do so
   if not mmCommandsScrollChild.fstrings[index] then
      mmCommandsScrollChild.fstrings[index] = mmCommandsScrollChild:CreateFontString("mmCommandsFS" .. index, "OVERLAY")
   end
    
   -- Set the font string to the correct font object, set the text to be the
   -- name of the font and set the height/width of the font string based on
   -- the size of the resulting 'string'.
   local fs = mmCommandsScrollChild.fstrings[index]
   --fs:SetFontObject(GameFontNormal)
   fs:SetPoint("LEFT", 0, 0)
   fs:SetFont("Fonts\\ARIALN.ttf", 12)
   fs:SetText(fname)
   local fwidth = fs:GetStringWidth()
   local fheight = fs:GetStringHeight()
   fs:SetSize(fwidth, fheight)
    
   --First line, set the anchor point for the rest to follow below.
   if index == 1 then
      fs:SetPoint("TOPLEFT", 10, 0)
      height = height + fheight
   else
      fs:SetPoint("TOPLEFT", mmCommandsScrollChild.fstrings[index - 1], "BOTTOMLEFT", 0, - PADDING)
      height = height + fheight + PADDING
   end
    
   -- Update the 'max' width of the frame
   width = (fwidth > width) and fwidth or width
end
 
-- Set the size of the scroll child
mmCommandsScrollChild:SetSize(width, height)
 
-- Size and place the parent frame, and set the scrollchild to be the
-- frame of font strings we've created
--fp:SetSize(width, 400)
mmCommands:SetSize(550, 400)
mmCommands:SetPoint("CENTER", UIParent, -100, 100)
mmCommands:SetScrollChild(mmCommandsScrollChild)
tinsert(UISpecialFrames, "mmCommandsFrame")
mmCommands:Hide()
 
mmCommandsScrollChild:SetSize(width, height)
 
-- Set up the scrollbar to work properly
local scrollMax = height - 400
mmCommandsScrollBar:SetOrientation("VERTICAL");
mmCommandsScrollBar:SetSize(16, 366)
mmCommandsScrollBar:SetPoint("TOPLEFT", mmCommands, "TOPRIGHT", 0, -19)
mmCommandsScrollBar:SetMinMaxValues(0, scrollMax)
mmCommandsScrollBar:SetValue(0)
mmCommandsScrollBar:SetScript("OnValueChanged", function(self)
	mmCommands:SetVerticalScroll(self:GetValue())
end)
 
-- Enable mousewheel scrolling
mmCommands:EnableMouseWheel(true)
mmCommands:SetScript("OnMouseWheel", function(self, delta)
	local current = mmCommandsScrollBar:GetValue()  
	if IsShiftKeyDown() and (delta > 0) then
		mmCommandsScrollBar:SetValue(0)
	elseif IsShiftKeyDown() and (delta < 0) then
		mmCommandsScrollBar:SetValue(scrollMax)
	elseif (delta < 0) and (current < scrollMax) then
		mmCommandsScrollBar:SetValue(current + 20)
	elseif (delta > 0) and (current > 1) then
		mmCommandsScrollBar:SetValue(current - 20)
	end
end)



local bottomButton = CreateFrame("Button", "bottomButton", mmCommandsFrame, "UIPanelButtonTemplate")
bottomButton:SetPoint("Bottom", 0, -20)
bottomButton:SetWidth(80)
bottomButton:SetHeight(22)
bottomButton:SetText("Close")
bottomButton:SetNormalFontObject("GameFontNormalSmall")
bottomButton:SetScript("OnClick", function(self, arg)
    mmCommandsFrame:Hide()
end)

local topBar = CreateFrame("Frame", "topButton", mmCommandsFrame, "ThinGoldEdgeTemplate")
topBar:SetPoint("TOP", 0, 16)
topBar:SetWidth(550)
topBar:SetHeight(18)
topBar.fs = topBar:CreateFontString("topBarFS", "OVERLAY")
topBar.fs:SetFontObject(QuestDifficulty_Standard)
topBar.fs:SetText("Multimod Commands")
topBar.fs:SetPoint("CENTER", 0, 0)
topBar:SetMovable(true)
topBar:EnableMouse(true)
topBar:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self:GetParent().isMoving then
		self:GetParent():StartMoving();
		self:GetParent().isMoving = true;
	end
end)
topBar:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self:GetParent().isMoving then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)
topBar:SetScript("OnHide", function(self)
	if (self:GetParent().isMoving) then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)

local xCloseButton = CreateFrame("Button", "xClose", mmCommandsScrollBar, "UIPanelCloseButton")
xCloseButton:SetPoint("Top", 0.25, 41)
xCloseButton:SetWidth(31)
xCloseButton:SetHeight(31)
xCloseButton:SetScript("OnClick", function(self, arg)
    mmCommandsFrame:Hide()
end)

------------------
--Keystone Panel--
------------------

--Sort keystone list by class and then name, lua has a serious lack of good sort functions...
local sortedKeystoneArray = {}
function sortKeystoneData()
	sortedKeystoneArray = {}
	local deathknight = {}
	local demonhunter = {}
	local druid = {}
	local hunter = {}
	local mage = {}
	local monk = {}
	local paladin = {}
	local priest = {}
	local rogue = {}
	local shaman = {}
	local warlock = {}
	local warrior = {}
	local noclass = {}
	local data = Multimod.data.global.keystones
	--We use custom func pairsByKeysTwo here to go over the array in alphabetical order. Credit: http://www.lua.org/pil/19.3.html
	for key, value in pairsByKeys(data) do
		local class = value.class
		local keyItemLink = value.keystone
		key = string.gsub(key, "_", " ")
		local split = explode(" ", key)
		if (split == nil) then
			table.insert(noclass, "|cff9CD6DEAn error occured with " ..  name)
		else
			local name = split[1]
			local realm = split[2]
			if (realm ~= Multimod.homeServer) then
			name = name .. "-" .. realm
			end
			if (value.class == "DEATHKNIGHT") then
				table.insert(deathknight, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "DEMONHUNTER") then
				table.insert(demonhunter, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "DRUID") then
				table.insert(druid, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "HUNTER") then
				table.insert(hunter, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "MAGE") then
				table.insert(mage, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "MONK") then
				table.insert(monk, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "PALADIN") then
				table.insert(paladin, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "PRIEST") then
				table.insert(priest, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "ROGUE") then
				table.insert(rogue, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "SHAMAN") then
				table.insert(shaman, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "WARLOCK") then
				table.insert(warlock, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			elseif (value.class == "WARRIOR") then
				table.insert(warrior, "|c" .. RAID_CLASS_COLORS[value.class].colorStr ..  name .. " |cffffffff- " .. keyItemLink)
			else
				table.insert(noclass, "|cff9CD6DE" ..  name .. " |cffffffff- " .. keyItemLink)
			end
		end
	end	
	if (next(deathknight) ~= nil) then
		for key, value in pairs(deathknight) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(demonhunter) ~= nil) then
		for key, value in pairs(demonhunter) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(druid) ~= nil) then
		for key, value in pairs(druid) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(hunter) ~= nil) then
		for key, value in pairs(hunter) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(mage) ~= nil) then
		for key, value in pairs(mage) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(monk) ~= nil) then
		for key, value in pairs(monk) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(paladin) ~= nil) then
		for key, value in pairs(paladin) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(priest) ~= nil) then
		for key, value in pairs(priest) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(rogue) ~= nil) then
		for key, value in pairs(rogue) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(shaman) ~= nil) then
		for key, value in pairs(shaman) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(warlock) ~= nil) then
		for key, value in pairs(warlock) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(warrior) ~= nil) then
		for key, value in pairs(warrior) do
			table.insert(sortedKeystoneArray, value)
		end
	end
	if (next(noclass) ~= nil) then
		for key, value in pairs(noclass) do
			table.insert(sortedKeystoneArray, value)
		end
	end
end

SLASH_KEYSTONECMD1, SLASH_KEYSTONECMD2, SLASH_KEYSTONECMD3 = '/keystones', '/keystone', '/ks';
function SlashCmdList.KEYSTONECMD(msg, editBox)
	Multimod:showKeystoneList()
end

function Multimod:showKeystoneList()
	if keystoneListFrame:IsVisible() then
    	keystoneListFrame:Hide()
    else
    	createKeystoneArray()
    	createKeystoneFrame()
    	keystoneListFrame:Show()
    	keystoneListFrame:SetFrameLevel(1000)
    	keystoneListFrame:SetFrameStrata("DIALOG")
    end
end

local keystoneArray = {}
--Need to create the array when command runs to include any new keys looted, also becaus the database doesn't load till OnInitialize(). 
function createKeystoneArray()
	sortKeystoneData()
	keystoneArray = {}
	if (next(sortedKeystoneArray) == nil) then
		table.insert(keystoneArray, "|cffFFFF00No keystones looted this week yet.")
		table.insert(keystoneArray, " ")
		table.insert(keystoneArray, "|cffFFFF00This list requires you to see the keys being looted")
		table.insert(keystoneArray, "|cffFFFF00so team your MB groups like normal when getting")
		table.insert(keystoneArray, "|cffFFFF00your weekly keys/chest.")
	else
		for key, value in pairs(sortedKeystoneArray) do
			table.insert(keystoneArray, value)
		end
	end
end

local keystoneList = CreateFrame("ScrollFrame", "keystoneListFrame", keystoneList, "InsetFrameTemplate")
keystoneList:Hide()
keystoneListFrame:SetToplevel(true)
keystoneListFrame:SetMovable(true)
keystoneListFrame:EnableMouse(true)
tinsert(UISpecialFrames, "keystoneListFrame")
keystoneListFrame:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving();
		self.isMoving = true;
	end
end)
keystoneListFrame:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)
keystoneListFrame:SetScript("OnHide", function(self)
	if (self.isMoving) then
		self:StopMovingOrSizing();
		self.isMoving = false;
	end
end)
 
-- Create the slider that will be used to scroll through the results
local keystoneListScrollBar = CreateFrame("Slider", "keystoneListScrollBarFrame", keystoneList, "UIPanelScrollBarTemplate")
keystoneListScrollBar.bg = keystoneListScrollBar:CreateTexture(nil, "BACKGROUND")
keystoneListScrollBar.bg:SetAllPoints(true)
keystoneListScrollBar.bg:SetColorTexture(0, 0, 0, 0.6)

-- Create a table that will contain the font strings themselves
--keystoneListScrollChild.fstrings = keystoneListScrollChild.fstrings or {}
local keystoneListScrollChild = CreateFrame("Frame", "keystoneListScrollChildFrame")
-- This changes the padding between font strings vertically
local PADDING = 1
 
-- Store the max width and overall height of the scroll child
local frameheight = 350
local framewidth = 260
local height = 0
local width = framewidth

---This is a really ugly frame code, I'll clean it up eventually.

--We don't load the text body till the command to show frame is used, loading every time makes sure new keys looted are added.
--Also we can't just load it at addon load time becaus the db isn't loaded strait away.
keystoneListScrollChild.fstrings = {}
function createKeystoneFrame()
	--Wipe the font strings every load.
	for i, v in ipairs(keystoneListScrollChild.fstrings) do
		v:SetPoint("LEFT", 0, 0)
		v:SetFont("Fonts\\ARIALN.ttf", 11)
		v:SetText("")
	end
	
	--Iterate the lines of text to add.
	local index = 0
	for com, fname in ipairs(keystoneArray) do
		index = index + 1
		-- If the font string is not created, do so
		if not keystoneListScrollChild.fstrings[index] then
			keystoneListScrollChild.fstrings[index] = keystoneListScrollChild:CreateFontString("keystoneListFS" .. index, "OVERLAY")
		end
		local fs = keystoneListScrollChild.fstrings[index]
		fs:SetPoint("LEFT", 0, 0)
		fs:SetFont("Fonts\\ARIALN.ttf", 11)
		fs:SetText(fname)
		local fwidth = fs:GetStringWidth()
		local fheight = fs:GetStringHeight()
		--fs:SetSize(fwidth, fheight)
		--First line, set the anchor point for the rest to follow below.
		if index == 1 then
			fs:SetPoint("TOPLEFT", 10, -10)
			height = height + fheight
		else
			fs:SetPoint("TOPLEFT", keystoneListScrollChild.fstrings[index - 1], "BOTTOMLEFT", 0, - PADDING)
			height = height + fheight + PADDING
		end
		--Uncomment this to grow frame wider if the text is wider than the default frame.
		width = (fwidth > width) and fwidth or width
	end

	-- Set the size of the scroll child
	keystoneListScrollChild:SetSize(width, height)
	-- Size and place the parent frame, and set the scrollchild to be the
	keystoneList:SetSize(framewidth, frameheight)
	keystoneList:SetPoint("CENTER", UIParent, -100, 100)
	keystoneList:SetScrollChild(keystoneListScrollChild)
	--keystoneList:Hide()
	keystoneListScrollChild:SetSize(width, height)
 
	-- Set the scrollbar
	local scrollMax = height - 200
	if (scrollMax < 2) then
		scrollMax = 2
	end
	keystoneListScrollBar:SetOrientation("VERTICAL");
	keystoneListScrollBar:SetSize(16, frameheight - 49) --Minus 49 to make the X close button flush with the top of the main frame.
	keystoneListScrollBar:SetPoint("TOPLEFT", keystoneList, "TOPRIGHT", 0, -34)
	keystoneListScrollBar:SetMinMaxValues(0, scrollMax)
	keystoneListScrollBar:SetValue(0)
	keystoneListScrollBar:SetScript("OnValueChanged", function(self)
		keystoneList:SetVerticalScroll(self:GetValue())
	end)
	
	--Enable mousewheel scrolling
	keystoneList:EnableMouseWheel(true)
	keystoneList:SetScript("OnMouseWheel", function(self, delta)
		local current = keystoneListScrollBar:GetValue()
		if IsShiftKeyDown() and (delta > 0) then
			keystoneListScrollBar:SetValue(0)
		elseif IsShiftKeyDown() and (delta < 0) then
			keystoneListScrollBar:SetValue(scrollMax)
		elseif (delta < 0) and (current < scrollMax) then
			keystoneListScrollBar:SetValue(current + 20)
		elseif (delta > 0) and (current > 1) then
			keystoneListScrollBar:SetValue(current - 20)
		end
	end)
end

--Bottom Close button
local keystoneListBottomButton = CreateFrame("Button", "keystoneListBottomButton", keystoneListFrame, "UIPanelButtonTemplate")
keystoneListBottomButton:SetPoint("Bottom", 0, -20)
keystoneListBottomButton:SetWidth(80)
keystoneListBottomButton:SetHeight(22)
keystoneListBottomButton:SetText("Close")
keystoneListBottomButton:SetNormalFontObject("GameFontNormalSmall")
keystoneListBottomButton:SetScript("OnClick", function(self, arg)
	keystoneListFrame:Hide()
end)

--Top right X close button
local ksCloseButton = CreateFrame("Button", "xClose", keystoneListScrollBar, "UIPanelCloseButton")
ksCloseButton:SetPoint("Top", 0.25, 41)
ksCloseButton:SetWidth(31)
ksCloseButton:SetHeight(31)
ksCloseButton:SetScript("OnClick", function(self, arg)
	keystoneListFrame:Hide()
end)

--Top bar for the title
local keystoneListTopBar = CreateFrame("Frame", "keystoneListTopButton", keystoneListFrame, "ThinGoldEdgeTemplate")
keystoneListTopBar:SetPoint("TOP", 0, 16)
keystoneListTopBar:SetWidth(100)
keystoneListTopBar:SetHeight(18)
keystoneListTopBar.fs = keystoneListTopBar:CreateFontString("topBarFS", "OVERLAY")
keystoneListTopBar.fs:SetFontObject(QuestDifficulty_Standard)
keystoneListTopBar.fs:SetText("Keystones")
keystoneListTopBar.fs:SetPoint("CENTER", 0, 0)
keystoneListTopBar:SetMovable(true)
keystoneListTopBar:EnableMouse(true)
keystoneListTopBar:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self:GetParent().isMoving then
		self:GetParent():StartMoving();
		self:GetParent().isMoving = true;
	end
end)
keystoneListTopBar:SetScript("OnMouseUp", function(self, button)
	if button == "LeftButton" and self:GetParent().isMoving then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)
keystoneListTopBar:SetScript("OnHide", function(self)
	if (self:GetParent().isMoving) then
		self:GetParent():StopMovingOrSizing();
		self:GetParent().isMoving = false;
	end
end)