------------------
--Holiday Events--
------------------


----------------------
--Love is in the Air--
----------------------

--Leave the instance after all 3 bosses are dead (mount box is instantly auto looted).
holidayBossCache = {}
local LoveIsInTheAir = CreateFrame("Frame")
LoveIsInTheAir:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
LoveIsInTheAir:SetScript("OnEvent", function(...)
	local  _ , event, _, _, sourceName, _, _, _, destName, _, _, spellId = CombatLogGetCurrentEventInfo()
	if (event == "UNIT_DIED" and (destName == "Apothecary Frye" or destName == "Apothecary Hummel" or destName == "Apothecary Baxter")) then
		table.insert(holidayBossCache, destName)
    	for i, v in ipairs(holidayBossCache) do
    		if (v == "Apothecary Frye") then
    			Frye = true
    		end
    		if (v == "Apothecary Hummel") then
    			Hummel = true
    		end
    		if (v == "Apothecary Baxter") then
    			Baxter = true
    		end
		end
		if (Frye == true and Hummel == true and Baxter == true) then
			holidayBossCache = {}
			Frye = false
			Hummel = false
			Baxter = false
			if (not Multimod.db.global.leave_love_seconds or Multimod.db.global.leave_love_seconds == nil) then
				Multimod.db.global.leave_love_seconds = 5;
			end
			zoneName = GetZoneText();
			if (Multimod.db.global.leave_love and zoneName == "Shadowfang Keep") then
				C_Timer.After(Multimod.db.global.leave_love_seconds, function()
					LoveIsInTheAir:leaveLoveInstance("Shadowfang Keep")
				end)
			end
		end
	end
end)

function LoveIsInTheAir:leaveLoveInstance(zone)
	Multimod:chatPrefixMsg("The Crown Chemical Co. defeated, leaving Shadowfang Keep.")
	LeaveParty();
end

--Auto start the encounter conversation when you open chat with the NPC.
local LoveIsInTheAir = CreateFrame("Frame")
LoveIsInTheAir:RegisterEvent("GOSSIP_SHOW")
LoveIsInTheAir:SetScript("OnEvent", function(self, event, ...)
	local npcName = UnitName("target")
	local zoneName = GetZoneText()
	if (Multimod.db.global.love_autotalk and npcName == "Apothecary Hummel" and zoneName == "Shadowfang Keep") then
		SelectGossipOption(1)
		Multimod:chatPrefixMsg("Started Love instance dialogue.")
	end
end)

--Destroy all useless Love is in the air loot you can't vendor.
SLASH_DESTROYLOVECMD1, SLASH_DESTROYLOVECMD2 = '/destroylove', '/deletelove';
function SlashCmdList.DESTROYLOVECMD(msg, editBox)
	if (Multimod.startDelay > time() and msg ~= "lowSpam") then
		Multimod:chatPrefixMsg("Please wait " .. Multimod.startDelaySeconds .. " seconds after logging in so the item cache can load properly. (" .. 
				(Multimod.startDelay - time()) .. " seconds left)")
		return
	end
	if (msg ~= "lowSpam") then
		Multimod:chatPrefixMsg("Destroying all non sellable |cffFFFF00Love Is In The Air|cff00FF00 items...")
	end
	local a = {}
	if (Multimod.db.global.love_ebonroses) then
		table.insert(a, "Bouquet of Ebon Roses")
	end
	if (Multimod.db.global.love_redroses) then
		table.insert(a, "Bouquet of Red Roses")
	end
	if (Multimod.db.global.love_lovelyrose) then
		table.insert(a, "Forever%-Lovely Rose")
	end
	if (Multimod.db.global.love_bravado) then
		table.insert(a, "\"Bravado\" Cologne")
	end
	if (Multimod.db.global.love_enchantress) then
		table.insert(a, "\"Enchantress\" Perfume")
	end
	if (Multimod.db.global.love_forever) then
		table.insert(a, "\"Forever\" Perfume")
	end
	if (Multimod.db.global.love_stalwart) then
		table.insert(a, "\"STALWART\" Cologne")
	end
	if (Multimod.db.global.love_victory) then
		table.insert(a, "\"VICTORY\" Perfume")
	end
	if (Multimod.db.global.love_wizardry) then
		table.insert(a, "\"Wizardry\" Cologne")
	end
	if (Multimod.db.global.love_heartcandies) then
		table.insert(a, "Bag of Heart Candies")
	end
	if (Multimod.db.global.love_boxofchocolates) then
		table.insert(a, "Box of Chocolates")
	end
	if (Multimod.db.global.love_greetingcard) then
		table.insert(a, "Faded Lovely Greeting Card")
	end
	if (Multimod.db.global.love_rosepetals) then
		table.insert(a, "Handful of Rose Petals")
	end
	if (Multimod.db.global.love_rocket) then
		table.insert(a, "Love Rocket")
	end
	if (Multimod.db.global.love_heartbreaker) then
		table.insert(a, "The Heartbreaker")
	end
	if (Multimod.db.global.love_toxic_wasteling) then
		table.insert(a, "Toxic Wasteling")
	end
	--Check if all items are unticked in options and array is empty
	if (next(a) == nil and msg ~= "lowSpam") then
   		Multimod:chatMsg("All Love Is In The Air items are unticked in options, nothing to destroy.")
   		return
	end
	local count = 0
	for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
    		for i, v in ipairs(a) do
      			local name=GetContainerItemLink(bag,slot)
				if (name and string.find(name, v) and name ~= nill and name ~= '') then
					--Check if you have the toy uploaded before deleting it.
					local collected = PlayerHasToy(50471) --The Heartbreaker = 50471
    				if (string.find(name, "The Heartbreaker") and collected == false) then
    					Multimod:chatPrefixMsg("Found The Heartbreaker but you haven't collected this toy yet, please use it!")
					--Be careful not to delete the mount while deleting "Love Rocket", not that it would ever be in bags and unused.
					elseif (string.find(name, "Big Love Rocket") == nil) then
						PickupContainerItem(bag,slot)
						DeleteCursorItem()
						Multimod:chatMsg("Destroyed: " .. name .. "|cff00FF00.")
						count = count + 1
					end
				end
			end
		end
	end
	if (msg ~= "lowSpam") then
		Multimod:chatMsg("Done, " .. count .. " items found and destroyed.")
	end
end

-------------
--Halloween--
-------------

--Leave the instance after the Headless Horseman is dead (mount box is instantly auto looted).
local Halloween = CreateFrame("Frame")
Halloween:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
Halloween:SetScript("OnEvent", function(...)
	local  _ , event, _, _, sourceName, _, _, _, destName, _, _, spellId = CombatLogGetCurrentEventInfo()
	if (event == "UNIT_DIED" and destName == "Head of the Horseman") then
		if (not Multimod.db.global.leave_halloween_seconds or Multimod.db.global.leave_halloween_seconds == nil) then
			Multimod.db.global.leave_halloween_seconds = 5;
		end
		local zoneName = GetZoneText();
		if (Multimod.db.global.leave_halloween and zoneName == "Scarlet Monastery") then
			Multimod:chatPrefixMsg("The Headless Horseman defeated, leaving Scarlet Monastery in " .. Multimod.db.global.leave_halloween_seconds .. " seconds.")
			C_Timer.After(Multimod.db.global.leave_halloween_seconds, function()
				Halloween:leaveHalloweenInstance()
			end)
		end
	end
end)

function Halloween:leaveHalloweenInstance()
	LeaveParty();
end

--Auto start the encounter conversation when you open chat with the NPC.
--This is a work in progress, I'll have to test the event on halloween since you talk to a pumpkin object and not a npc to start it.
local Halloween = CreateFrame("Frame")
Halloween:RegisterEvent("GOSSIP_SHOW")
Halloween:SetScript("OnEvent", function(self, event, ...)
	local zoneName = GetZoneText()
	local title1, gossip1 = GetGossipOptions()
	if (Multimod.db.global.halloween_autotalk and title1 == "Call the Headless Horseman." and zoneName == "Scarlet Monastery") then
		SelectGossipOption(1)
		Multimod:chatPrefixMsg("Started Halloween instance dialogue.")
	end
end)

--Destroy all useless Halloween loot you can't vendor after you've been farming the dailies and candy boxes etc.
SLASH_DESTROYHALLOWEENCMD1, SLASH_DESTROYHALLOWEENCMD2 = '/destroyhalloween', '/deletehalloween';
function SlashCmdList.DESTROYHALLOWEENCMD(msg, editBox)
	if (Multimod.startDelay > time()  and msg ~= "lowSpam") then
		Multimod:chatPrefixMsg("Please wait " .. Multimod.startDelaySeconds .. " seconds after logging in so the item cache can load properly. (" .. 
				(Multimod.startDelay - time()) .. " seconds left)")
		return
	end
	if (msg ~= "lowSpam") then
		Multimod:chatPrefixMsg("Destroying all non sellable |cffFFFF00Halloween|cff00FF00 items...")
	end
	local a = {}
	if (Multimod.db.global.halloween_pennypouch) then
		table.insert(a, "Penny Pouch")
	end
	if (Multimod.db.global.halloween_wand) then
		table.insert(a, "Hallowed Wand")
	end
	if (Multimod.db.global.halloween_malemask) then
		table.insert(a, "[A-Za-z] Male Mask")
	end
	if (Multimod.db.global.halloween_femalemask) then
		table.insert(a, "[A-Za-z] Female Mask")
	end
	if (Multimod.db.global.halloween_cinnamonball) then
		table.insert(a, "Pyroblast Cinnamon Ball")
	end
	if (Multimod.db.global.halloween_gnerds) then
		table.insert(a, "G.N.E.R.D.S")
	end
	if (Multimod.db.global.halloween_toothpick) then
		table.insert(a, "Tooth Pick")
	end
	if (Multimod.db.global.halloween_spearmintcandy) then
		table.insert(a, "Soothing Spearmint Candy")
	end
	if (Multimod.db.global.halloween_feltaffy) then
		table.insert(a, "Chewy Fel Taffy")
	end
	if (Multimod.db.global.halloween_lantern) then
		table.insert(a, "Weighted Jack%-o")
	end
	if (Multimod.db.global.halloween_hallowedhelm) then
		table.insert(a, "Hallowed Helm")
	end
	if (Multimod.db.global.halloween_sinistersquashling) then
		table.insert(a, "Sinister Squashling")
	end
	--Check if all items are unticked in options and array is empty
	if (next(a) == nil and msg ~= "lowSpam") then
   		Multimod:chatMsg("All halloween items are unticked in options, nothing to destroy.")
   		return
	end
	local count = 0
	for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
    		for i, v in ipairs(a) do
      			local name=GetContainerItemLink(bag,slot)
				if (name and string.find(name, v) and name ~= nill and name ~= '') then
					PickupContainerItem(bag,slot)
					DeleteCursorItem()
					Multimod:chatMsg("Destroyed: " .. name .. "|cff00FF00.")
					count = count + 1
				end
			end
		end
	end
	if (msg ~= "lowSpam") then
		Multimod:chatMsg("Done, " .. count .. " items found and destroyed.")
	end
end

---------------
--Winter Veil--
---------------

local WinterVeil = CreateFrame("Frame")
WinterVeil:RegisterEvent("GOSSIP_SHOW")
WinterVeil:SetScript("OnEvent", function(self, event, ...)
	if (Multimod.db.global.xmas_garrisondailies) then
		--When you open a NPC quest dialogue or after accepting a quest and it reverts back to start dialogue
		local pull_name = GetGossipAvailableQuests() --Name of quest at top of list to pull
		local handin_name = GetGossipActiveQuests() --Name of quest at top of list to hand in
		if pull_name == "Menacing Grumplings" or pull_name == "Where Are the Children?" or pull_name == "Grumpus" or pull_name == "What Horrible Presents!" then
			SelectGossipAvailableQuest(1)
		elseif handin_name == "Menacing Grumplings" or handin_name == "Where Are the Children?" or handin_name == "Grumpus" or handin_name == "What Horrible Presents!" then
			SelectGossipActiveQuest(1)
		end
	end
end)

local WinterVeil = CreateFrame("Frame")
WinterVeil:RegisterEvent("QUEST_DETAIL")
WinterVeil:SetScript("OnEvent", function(self, event, ...)
	if (Multimod.db.global.xmas_garrisondailies) then
		--When you select a quest
		local pull_name = GetGossipAvailableQuests() --Name of quest at top of list to pull
		if pull_name == "Menacing Grumplings" or pull_name == "Where Are the Children?" or pull_name == "Grumpus" or pull_name == "What Horrible Presents!" then
			AcceptQuest()
		end
	end
end)

local WinterVeil = CreateFrame("Frame")
WinterVeil:RegisterEvent("QUEST_COMPLETE")
WinterVeil:SetScript("OnEvent", function(self, event, ...)
	if (Multimod.db.global.xmas_garrisondailies) then
		--Runs when the quest hand in window loads after you select which quest to hand in
		--Note if only 1 quest to hand in the npc dialogue window auto goes to this complete window
		local handin_name = GetTitleText()
		if handin_name == "Menacing Grumplings" or handin_name == "Where Are the Children?" or handin_name == "Grumpus" or handin_name == "What Horrible Presents!" then
			GetQuestReward(1)
		end
	end
end)

--Destroy all useless Winter Veil loot you can't vendor etc.
SLASH_DESTROYXMASCMD1, SLASH_DESTROYXMASCMD2 = '/destroyxmas', '/deletexmas';
function SlashCmdList.DESTROYXMASCMD(msg, editBox)
	if (Multimod.startDelay > time()  and msg ~= "lowSpam") then
		Multimod:chatPrefixMsg("Please wait " .. Multimod.startDelaySeconds .. " seconds after logging in so the item cache can load properly. (" .. 
				(Multimod.startDelay - time()) .. " seconds left)")
		return
	end
	if (msg ~= "lowSpam") then
		Multimod:chatPrefixMsg("Destroying all non-sellable |cffFFFF00Winter Veil|cff00FF00 items...")
	end
	local a = {}
	if (Multimod.db.global.xmas_savagesnowball) then
		table.insert(a, "Savage Snowball")
	end
	--Check if all items are unticked in options and array is empty
	if (next(a) == nil and msg ~= "lowSpam") then
   		Multimod:chatMsg("All Winter Veil items are unticked in options, nothing to destroy.")
   		return
	end
	local count = 0
	for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
    		for i, v in ipairs(a) do
      			local name=GetContainerItemLink(bag,slot)
				if (name and string.find(name, v) and name ~= nill and name ~= '') then
					PickupContainerItem(bag,slot)
					DeleteCursorItem()
					Multimod:chatMsg("Destroyed: " .. name .. "|cff00FF00.")
					count = count + 1
				end
			end
		end
	end
	if (msg ~= "lowSpam") then
		Multimod:chatMsg("Done, " .. count .. " items found and destroyed.")
	end
end